﻿Imports Microsoft.TeamFoundation.Build.Client
Imports System.Management.Automation

<Cmdlet(VerbsLifecycle.Start, TeamSystemNouns.Build, ConfirmImpact:=ConfirmImpact.Low, SupportsShouldProcess:=True)> _
Public Class StartBuildCmdlet
    Inherits TeamProjectCmdletBase

    Public Sub New()
    End Sub

    Private _name As String

    <Parameter(Position:=2, Mandatory:=True, ValueFromPipelineByPropertyName:=True), ValidateNotNullOrEmpty()> _
    Public Property Name() As String
        Get
            Return _name
        End Get
        Set(ByVal value As String)
            _name = value
        End Set
    End Property

    Private _passThru As SwitchParameter

    <Parameter()> _
    Public Property PassThru() As SwitchParameter
        Get
            Return _passThru
        End Get
        Set(ByVal value As SwitchParameter)
            _passThru = value
        End Set
    End Property

    Protected Overrides Sub ProcessRecord()
        Dim build As IQueuedBuild = Nothing

        If ShouldProcess(Name) Then
            build = BuildServer.QueueBuild(BuildServer.GetBuildDefinition(TeamProject, Name))
        End If

        If PassThru Then
            WriteObject(build)
        End If
    End Sub
End Class
