﻿Imports Microsoft.TeamFoundation.Build.Client
Imports System.Management.Automation

<Cmdlet(VerbsLifecycle.Stop, TeamSystemNouns.Build, ConfirmImpact:=ConfirmImpact.Medium, SupportsShouldProcess:=True)> _
Public Class StopBuildCmdlet
    Inherits TeamFoundationServerCmdletBase

    Public Sub New()
    End Sub

    Private _uri As String

    <Parameter(Position:=2, ValueFromPipelineByPropertyName:=True)> _
    Public Property Uri() As String
        Get
            Return _uri
        End Get
        Set(ByVal value As String)
            _uri = value
        End Set
    End Property

    Private _passThru As SwitchParameter

    <Parameter()> _
    Public Property PassThru() As SwitchParameter
        Get
            Return _passThru
        End Get
        Set(ByVal value As SwitchParameter)
            _passThru = value
        End Set
    End Property

    Protected Overrides Sub ProcessRecord()
        Dim build As IBuildDetail
        build = BuildServer.GetMinimalBuildDetails(New Uri(Uri))

        If ShouldProcess(Uri) Then
            build.Stop()
        End If

        If PassThru.IsPresent Then
            build.RefreshMinimalDetails()
            WriteObject(build)
        End If
    End Sub
End Class
