﻿Imports Microsoft.TeamFoundation.Build.Client
Imports System.Management.Automation

<Cmdlet(VerbsLifecycle.Enable, TeamSystemNouns.BuildDefinition, ConfirmImpact:=ConfirmImpact.Low, SupportsShouldProcess:=True)> _
Public Class EnableBuildDefinitionCmdlet
    Inherits TeamProjectCmdletBase

    Public Sub New()
    End Sub

    Private _name As String

    <Parameter(Position:=2, Mandatory:=True, ValueFromPipelineByPropertyName:=True), ValidateNotNullOrEmpty()> _
    Public Property Name() As String
        Get
            Return _name
        End Get
        Set(ByVal value As String)
            _name = value
        End Set
    End Property

    Private _passThru As SwitchParameter

    <Parameter()> _
    Public Property PassThru() As SwitchParameter
        Get
            Return _passThru
        End Get
        Set(ByVal value As SwitchParameter)
            _passThru = value
        End Set
    End Property

    Protected Overrides Sub ProcessRecord()
        Dim buildDefinition As IBuildDefinition
        buildDefinition = buildServer.GetBuildDefinition(TeamProject, Name)
        buildDefinition.Enabled = True

        If ShouldProcess(Name) Then
            buildDefinition.Save()
        End If

        If PassThru.IsPresent Then
            buildDefinition.Refresh()
            WriteObject(buildDefinition)
        End If
    End Sub
End Class