﻿Imports Microsoft.TeamFoundation.Build.Client
Imports System.Management.Automation

<Cmdlet(VerbsCommon.Get, TeamSystemNouns.QueuedBuild)> _
Public Class GetQueuedBuild
    Inherits TeamProjectCmdletBase

    Public Sub New()
    End Sub

    Private _id As Integer

    <Parameter(Position:=2, ValueFromPipelineByPropertyName:=True), ValidateRange(1, Integer.MaxValue)> _
    Public Property Id() As Integer
        Get
            Return _id
        End Get
        Set(ByVal value As Integer)
            _id = value
        End Set
    End Property

    Protected Overrides Sub ProcessRecord()
        If Id > 0 Then
            WriteObject(BuildServer.GetQueuedBuild(Id, QueryOptions.None))
        Else
            Dim queuedBuildsView As IQueuedBuildsView
            queuedBuildsView = BuildServer.CreateQueuedBuildsView(TeamProject)
            queuedBuildsView.QueryOptions = QueryOptions.None
            queuedBuildsView.Refresh(False)

            WriteObject(queuedBuildsView.QueuedBuilds, True)
        End If
    End Sub
End Class