﻿Imports Microsoft.TeamFoundation.Build.Client
Imports System.Management.Automation

<Cmdlet(VerbsLifecycle.Suspend, TeamSystemNouns.QueuedBuild, ConfirmImpact:=ConfirmImpact.Low, SupportsShouldProcess:=True)> _
Public Class SuspendQueuedBuildCmdlet
    Inherits TeamFoundationServerCmdletBase

    Public Sub New()
    End Sub

    Private _id As Integer

    <Parameter(Position:=2, Mandatory:=True, ValueFromPipelineByPropertyName:=True), ValidateRange(1, Integer.MaxValue)> _
    Public Property Id() As Integer
        Get
            Return _id
        End Get
        Set(ByVal value As Integer)
            _id = value
        End Set
    End Property

    Private _passThru As SwitchParameter

    <Parameter()> _
    Public Property PassThru() As SwitchParameter
        Get
            Return _passThru
        End Get
        Set(ByVal value As SwitchParameter)
            _passThru = value
        End Set
    End Property

    Protected Overrides Sub ProcessRecord()
        Dim queuedBuild As IQueuedBuild
        queuedBuild = buildServer.GetQueuedBuild(Id, QueryOptions.None)
        queuedBuild.Postpone()

        If ShouldProcess(Id.ToString()) Then
            queuedBuild.Save()
        End If

        If PassThru.IsPresent Then
            queuedBuild.Refresh(QueryOptions.None)
            WriteObject(queuedBuild)
        End If
    End Sub
End Class